//////////////////////////// usefull functions //////////////////////////////////////////////
// 解析json
function parseJson(jsonData){
    try{if(jsonData && !isJson(jsonData)) jsonData = JSON.parse(jsonData);}catch(e){}
    return jsonData;
}
//判断是否json对象
function isJson(obj){
    var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
    return isjson;
}
////////////////////////////////////////////////////////////////////////////////////////////

//全局变量初始化：
var proCount = 0, proTotal = ktList.length, proMask = {}; //进度数目、进度总数、每一题进度统计状态标记


/* 读写localStorage数据
 * setStorage方法参数：
 * {
 * "key": " "  //键值
 * "value":   //要保存的数据
 * }
 * getStorage方法参数：
 * {
 * "key": " "  //键值 (键值为 “ paperID_* ”时，是否直接返回一组筛选后的数据？)
 * "successCallback": ""   //回调函数名
 * }
 * getStorage方法回调函数 getAllAnswer 参数：
 * {
 * "key": "paperID_*"  //键值
 * "value": {"paperID_ktID":"","paperID_ktID":"","paperID_ktID":"","paperID_ktID":"",...}  //json数据
 * }
  * getStorage方法回调函数 getSinAnswer 参数：
 * {
 * "key": "paperID_ktID"  //键值
 * "value": " "  //字符串
 * }
 */
function setStorage(jsonData) {
	jsonData = parseJson(jsonData);
	var key = jsonData.key || "";
    var value = jsonData.value || "";
    try{ dictcn.setItem(JSON.stringify({'key':key, 'value':value})); }catch(e){}
}
function getStorage(jsonData) {
	jsonData = parseJson(jsonData);
	var key = jsonData.key || "";
    var successCallback = jsonData.successCallback || "";
    try{ dictcn.getItem(JSON.stringify({'key':key, 'successCallback':successCallback})); }catch(e){}
}
//getStorage 方法回调函数（读取当前考卷已保存的全部答案）
function getAllAnswer(jsonData){
	jsonData = parseJson(jsonData);
	paperAnswer = parseJson(jsonData.value) || {}; //json
	// 初始化进度统计
	for(var i in paperAnswer){
		if(paperAnswer[i]){
			proCount++;
			proMask[i] = 1;
			// 初始化答题状态面板
			var ktID = i.split('_')[2];
			var index = $.inArray(ktID, ktList);
			if(index > -1){
				$('#eSItem'+index).addClass('finished');
			}
			else {
				alert("错误：uwid在当前考卷中不存在！");
			}
		}
	}
	$('#progress').css({'-webkit-transform': 'scaleX('+proCount/proTotal+')'});
	if(proCount==proTotal){
		$('#progress').addClass('full');
	}
	//更新当前页面三道题的答案状态
	$('.swiper-slide').each(function(){
		var ktID = $(this).attr('id');
		var key = paperID +'_'+ ktID;
		if(paperAnswer[key]){
			$(this).find('.mylabel').each(function(){
				if(paperAnswer[key].indexOf($(this).attr('key')) != -1){
					$(this).addClass('active');
				}
			});
		}
	});
}
//getStorage 方法回调函数（读取当前考卷已保存的某个答案）
function getSinAnswer(jsonData){
	jsonData = parseJson(jsonData);
	var key = jsonData.key || "";
	var value = jsonData.value || ""; //字符串
}

/* 保存 currKtIndex
 * saveCurrKtIndex方法参数：
 * {
 * "paperID": "" 
 * "currKtIndex": "6"  
 * }
 */
 function saveCurrKtIndex(jsonData){
 	jsonData = parseJson(jsonData);
 	var paperID = jsonData.paperID || "";
	var currKtIndex = jsonData.currKtIndex;
	if(currKtIndex != 0 && !currKtIndex){
		currKtIndex = "";
	}
	try{ dictcn.saveCurrKtIndex(JSON.stringify({'paperID': paperID, 'currKtIndex': currKtIndex})); }catch(e){}
 }
 /* 请求习题数据方法
 * requestKtData方法参数：
 * {
 * "ktID": "" //题目uwid
 * "successCallback": ""   //回调函数名
 * }
 */
 function requestKtData(jsonData){
 	jsonData = parseJson(jsonData);
 	var ktID = jsonData.ktID || "";
	var successCallback = jsonData.successCallback || "";
	try{ dictcn.requestKtData(JSON.stringify({'ktID': ktID, 'successCallback': successCallback})); }catch(e){}
 }
 //请求习题数据方法回调方法1--保存到 ktData中
 function saveDataInKtData(jsonData){
 	jsonData = parseJson(jsonData);
 	var ktID = jsonData.ktID || "";
	var data = jsonData.data || "";
	if(ktID && data){
		ktData[ktID] = data;
	}
 }
 //请求习题数据回调方法2--保存到 ktData中且更新对应空swiper
 function saveDataRefreshSwiper(jsonData){
 	jsonData = parseJson(jsonData);
 	var ktID = jsonData.ktID || "";
	var data = jsonData.data || "";
	if(ktID && data){
		ktData[ktID] = data;
		refreshSwiperContent(ktID,data);
	}
 }
 function refreshSwiperContent(ktID,data){
 	var htmlText = assembleInnerHtml(data,ktID);
	$('#'+ktID).html(htmlText);
	//绑定点击事件
    labelClick(ktID);
    //更新图片链接
    askRefreshImgUrl(ktID);
 }

 /* 请求图片实际链接方法
 * requestImgUrl方法参数：
 * {
 * "name": "" //图片name
 * "paperID": "" //试卷id
 * "successCallback": ""   //回调函数名
 * }
  * 回调方法refreshImgUrl接收参数：
 * {
 * "name": "" //图片name
 * "url": ""   //实际图片链接
 * }
 */
 function requestImgUrl(jsonData){
 	jsonData = parseJson(jsonData);
 	var name = jsonData.name || "";
 	var paperID = jsonData.paperID || "";
 	var ktID = jsonData.ktID || "";
	var successCallback = jsonData.successCallback || "";
	try{ dictcn.requestImgUrl(JSON.stringify({'name': name, "paperID":paperID, 'ktID': ktID, 'successCallback': successCallback})); }catch(e){}
 }
 //requestImgUrl方法回调函数
 function refreshImgUrl(jsonData){
 	jsonData = parseJson(jsonData);
 	var name = jsonData.name || "";
	var url = jsonData.url || "";
	var ktID = jsonData.ktID || "";
	if(name && url){
		var img = $('#img'+ktID+name);
		$(img).attr('src',url);
		var arr = [];
		$(img).parent().parent().find('img').each(function(){
			arr.push($(this).attr('name'));
		});
		$(img).on('click',function(){
			if(!isSwipering){
				viewBigImg({"name": arr, "paperID":paperID, "showName":name});
			}
		});
	}
 }

 /* 反馈当前习题解答状况给客户端
 * refreshStudyStatus方法参数：
 * {
 * "id": "" //paperID
 * "uwid": "" //当前题目uwid
 * "state": "1/0" //是否已答题
 * }
 */
function refreshStudyStatus(jsonData){
    jsonData = parseJson(jsonData);
    var id = paperID || "";
    var uwid = jsonData.uwid || "";
    var state = jsonData.state || "";
    try{ dictcn.refreshStudyStatus(JSON.stringify({'id':id, 'uwid':uwid, 'state':state})); }catch(e){}
}

 /* 查看大图方法
 * viewBigImg方法参数：
 * {
 * "name": ["","",...] //当前面板中图片name数组
 * "showName": "" //标记显示数组中的哪个图片
 * }
 */
 function viewBigImg(jsonData){
 	jsonData = parseJson(jsonData);
 	var name = jsonData.name || "";
 	var paperID = jsonData.paperID || "";
 	var showName = jsonData.showName || "";
	try{ dictcn.viewBigImg(JSON.stringify({'name': name, "paperID":paperID, 'showName': showName})); }catch(e){}
 }


  /* js开放给native的接口方法
 * checkAnswerCard() //查看答题情况方法
 * handInPaper() //交卷方法
 */
//查看答题情况方法
var answerCardShow = 0; //记录是否已经打开答题情况面板
function checkAnswerCard(){
	if(answerCardShow){
		$('#examStatus').removeClass('show');
		setTimeout(function(){
			$('.notAnswerTip').removeClass("show");
			$('#examStaContainer').addClass('hidden');
			answerCardShow = 0;
		}, 600);
	}
	else {
		$('#examStaContainer').removeClass('hidden');
		setTimeout(function(){
			$('#examStatus').addClass('show');
			answerCardShow = 1;
		},50);
	}
	answerCardState({"state": answerCardShow});
}
//告诉native  answerCard当前是否打开
function answerCardState(jsonData){
	jsonData = parseJson(jsonData);
 	var state = jsonData.state || "0";
 	try{ dictcn.answerCardState(JSON.stringify({'state': state})); }catch(e){}
}
//交卷方法
function handInPaper(){
	//判断是否已经做完全部习题
	if(proCount == proTotal){
		//交卷
		var htmlText = '<p>本试卷所有题目均已答完，确认交卷并查看答案？</p><div class="cancelBtn">取消</div><div class="hanInBtn">交卷</div>';
		$('#warningPanel').html(htmlText);
		$('#warning').addClass('show');
		$('.cancelBtn').one('click',function(){
			$('#warningPanel').html("");
			$('#warning').removeClass('show');
		});
		$('.hanInBtn').one('click',function(){
			$('#warningPanel').html("");
			$('#warning').removeClass('show');
			try{ dictcn.receivePaper(JSON.stringify({'paperID': paperID, 'paperAnswer': paperAnswer})); }catch(e){}
		});
	}
	else {
		var diff = proTotal - proCount;
		var htmlText = '还有<span class="blueColorText">'+diff+'</span>道题没有选择答案，请选择答案后再交卷';
		$('.notAnswerTip').html(htmlText);
		$('.notAnswerTip').addClass("show");
		window.location.href = "#zhanweifu";
		if(!answerCardShow){
			checkAnswerCard();
		}
	}
}